package com.example.myapplication;

import android.content.Context;
import android.text.Editable;
import android.text.TextWatcher;
import android.util.AttributeSet;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;

import androidx.annotation.Nullable;

public class EmailValidator extends LinearLayout {
    EditText input ;
    TextView output;
    Validator validator;
    EmailValidatorListener listener;
    public EmailValidator(Context context) {
        super(context);
        setupUI();
    }

    public EmailValidator(Context context, @Nullable AttributeSet attrs) {
        super(context, attrs);
        setupUI();
    }

    public EmailValidator(Context context, @Nullable AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
        setupUI();
    }

    public EmailValidator(Context context, AttributeSet attrs, int defStyleAttr, int defStyleRes) {
        super(context, attrs, defStyleAttr, defStyleRes);
        setupUI();
    }
    private void setupUI(){
        View  layout = LayoutInflater.from(getContext())
                .inflate(R.layout.email_validator, (ViewGroup)getParent());
        output = layout.findViewById(R.id.textView2);
        input = layout.findViewById(R.id.editTextTextEmailAddress);
        input.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence charSequence, int i, int i1, int i2) {

            }

            @Override
            public void onTextChanged(CharSequence charSequence, int i, int i1, int i2) {

            }

            @Override
            public void afterTextChanged(Editable editable) {
                validate(editable.toString());
            }
        });
        validator = new DefaultValidator();
        addView(layout);

    }

    private void validate(String toString) {
        if(validator.isValid(toString)) {
            output.setText(validator.getValidText());
            if(listener != null )
                listener.isValid(true);
        }
        else {
            output.setText(validator.getInvalidText());
            if(listener != null )
                listener.isValid(false);
        }
    }
    public void setValidator(Validator newValidator){
        this.validator = newValidator;
    }
    public  void setListener(EmailValidatorListener listener){
        this.listener = listener;
    }
    public String getEmail(){
        return input.getText().toString();
    }
}
